<?
// $Id: triangle.php,v 1.1 2003/11/01 00:11:29 neufeind Exp $
/**
* Triangle data-element for a Image_Graph diagram
*
* @author   Stefan Neufeind <pear.neufeind@speedpartner.de>
* @package  Image_Graph
* @access   private
*/

require_once("Image/Graph/common.php");

class Image_Graph_Data_Triangle extends Image_Graph_Data_Common
{
    /**
    * Type of data element
    *
    * @var string
    * @access private
    */
    var $_type = "triangle";

    /**
    * Constructor for the class
    *
    * @param  object  parent object (of type Image_Graph_Diagram)
    * @param  array   numerical data to be drawn
    * @access public
    */
    function Image_Graph_Data_Triangle(&$parent, $data, $attributes)
    {
        if (!isset($attributes['size'])) {
            $attributes['size'] = 10;
        }
        parent::Image_Graph_Data_Common(&$parent, $data, $attributes);
    }

    /**
    * Draws diagram element 
    *
    * @param gd-resource image-resource to draw to
    * @access private
    */

    function drawGD(&$img)
    {
        $drawColor = imagecolorallocate($img, $this->_attributes["color"][0], $this->_attributes["color"][1], $this->_attributes["color"][2]);
        $numDatapoints = count($this->_datapoints);

        // compute side-length using Pythagoras so that square and rhomb look equal-size
        $sideLength = sqrt(2*$this->_attributes['size']*$this->_attributes['size']);
        $halfSizePixelUp = floor(($sideLength-1) / 2);
        $halfSizePixelSide = floor(($this->_attributes['size']-1) / 2);

        for ($counter=0; $counter<$numDatapoints; $counter++) {
            if (!is_null($this->_datapoints[$counter])) { // otherwise do not draw
                $points = array($this->_datapoints[$counter][0]               , $this->_datapoints[$counter][1]-$halfSizePixelSide,
                                $this->_datapoints[$counter][0]+$halfSizePixelSide, $this->_datapoints[$counter][1]+$halfSizePixelSide,
                                $this->_datapoints[$counter][0]-$halfSizePixelSide, $this->_datapoints[$counter][1]+$halfSizePixelSide);
                imagefilledpolygon ($img, $points, 3, $drawColor);
            }
        }
    }
}
?>
